$FUNCS->register_tag('set_custom_field', 'set_custom_field_handler');

function set_custom_field_handler($params, $node){
   global $CTX, $FUNCS, $PAGE, $DB, $Config;
   
   if( count($node->children) ) {die("ERROR: Tag \"".$node->name."\" is a self closing tag");}
            
   extract( $FUNCS->get_named_vars(
      array(
         'var'=>'',
         'val' =>'',
         'masterpage'=>'',
         'page'=>''
      ),
      $params)
   );

   $var = trim($var);
   if( $var && $val){
      if( !$masterpage ){
         die( "ERROR: Tag \"".$node->name."\": 'masterpage' attribute missing" );
      }

      $sql = "t.id = p.template_id and ";
      $sql .= "t.name = '".$DB->sanitize( $masterpage )."' and ";
      if( $page ){
           $sql .= "p.page_name = '".$DB->sanitize( $page )."' and ";
       }
       else{
           $sql .= "p.is_master = '1' and "; //if no page specified, use the default page
       }
       $sql .= "f.template_id = t.id and f.name = '".$DB->sanitize( $var )."'";

       $rs = $DB->select(K_TBL_TEMPLATES . ' t, ' . K_TBL_PAGES . ' p, ' . K_TBL_FIELDS . ' f' , array('p.id as pid', 'f.id as fid', 'f.k_type as field_type', 'f.search_type as type', 'f.default_data as default_data'), $sql );
       if( count($rs) ){
           $pid = $rs[0]['pid'];
           $fid = $rs[0]['fid'];
           $type = $rs[0]['type'];
           
           $table = ($type=='text') ? K_TBL_DATA_TEXT : K_TBL_DATA_NUMERIC;
           $rs = $DB->update( $table, array('value'=>$val), "page_id='".$DB->sanitize( $pid )."' and field_id='".$DB->sanitize( $fid )."'" );
        }
     }
}
